import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;
import java.util.StringTokenizer;

public class Monsters {

    public static void main(String[] args) throws IOException {
        BufferedReader sc = new BufferedReader(new InputStreamReader(System.in));

        String line;
        while ((line = sc.readLine()) != null) {
            int cells = Integer.parseInt(line);
            int[] chambers = new int[cells];

            StringTokenizer st = new StringTokenizer(sc.readLine());
            for (int i = 0; i < cells; i++) {
                int monster = Integer.parseInt(st.nextToken()) - 1;
                chambers[i] = monster;
            }

            int swaps = 0;

            for (int i = 0; i < cells; i++) {
                while (chambers[i] != i) {
                    int temp = chambers[chambers[i]];
                    chambers[chambers[i]] = chambers[i];
                    chambers[i] = temp;
                    swaps++;
                }
            }
            System.out.println(swaps);
        }
    }
}
