import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.StringTokenizer;

public class Northwest {

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        String line;
        while ((line = br.readLine()) != null && !line.isEmpty()) {
            long townsNo = Integer.parseInt(line);

            HashMap<Long, Long> b_plus = new HashMap<>();
            HashMap<Long, Long> b_minus = new HashMap<>();

            for (int i = 0; i < townsNo; i++) {
                StringTokenizer st = new StringTokenizer(br.readLine());
                long x = Integer.parseInt(st.nextToken());
                long y = Integer.parseInt(st.nextToken());

                long pos = y - x;
                long neg = y + x;

                if (b_plus.containsKey(pos)){
                    b_plus.put(pos, b_plus.get(pos) + 1);
                } else {
                    b_plus.put(pos, 1l);
                }

                if (b_minus.containsKey(neg)){
                    b_minus.put(neg, b_minus.get(neg) + 1);
                } else {
                    b_minus.put(neg, 1l);
                }
            }

            double pairs = townsNo * townsNo;
            long winner = 0;

            for (Long value : b_minus.values()) {
                winner += value * (value - 1);
            }

            for (Long value : b_plus.values()) {
                winner += value * (value - 1);
            }

            System.out.println(winner/pairs);
        }
    }
}
